<?php
// $Id: salsa.admin.inc,v 1.1.2.5 2011/02/24 17:53:53 jcnventura Exp $

/**
 * @file
 * Contains the administrative functions of the salsa module.
 *
 * This file is included by the salsa module, and includes the
 * settings form.
 */

/**
 * Menu callback for the Salsa module settings form.
 *
 * @ingroup forms
 */
function salsa_settings() {
  $form['salsa_api_url'] = array(
    '#type' => 'select',
    '#title' => t('Salsa service'),
    '#default_value' => variable_get('salsa_api_url', 'https://salsa.democracyinaction.org'),
    '#options' => array(
      'https://sandbox.salsalabs.com' => t('Developer Sandbox'),
      'https://salsa.democracyinaction.org' => t('Democracy In Action'),
      'https://salsa.wiredforchange.com' => t('Wired for Change'),
    ),
    '#description' => t('Salsa Service to use (Democracy In Action, Wired for change or sandbox.)'),
    '#required' => TRUE,
  );
  $form['salsa_anon_form'] = array(
    '#type' => 'fieldset',
    '#title' => t('Anonymous form credentials'),
    '#description' => t('Required for the use of anonymous supporter creation'),
  );
  $form['salsa_anon_form']['salsa_organization_key'] = array(
    '#type' => 'textfield',
    '#title' => t('Organization key'),
    '#default_value' => variable_get('salsa_organization_key', ''),
    '#maxlength' => 10,
    '#description' => t('Organization key provided by Salsa (visible in the footer of the Salsa HQ page)'),
    '#required' => TRUE,
  );

  $form['salsa_api_auth'] = array(
    '#type' => 'fieldset',
    '#title' => t('API authentication credentials'),
    '#description' => t('Required for the use of API services'),
  );
  $form['salsa_api_auth']['salsa_api_username'] = array(
    '#type' => 'textfield',
    '#title' => t('Campaign Manager username'),
    '#default_value' => variable_get('salsa_api_username', ''),
    '#maxlength' => 64,
  );
  $form['salsa_api_auth']['salsa_api_password'] = array(
    '#type' => 'textfield',
    '#title' => t('Campaign Manager password'),
    '#default_value' => variable_get('salsa_api_password', ''),
    '#maxlength' => 64,
  );

  if (module_exists('job_queue')) {
    $form['salsa_job_queue'] = array(
      '#type' => 'checkbox',
      '#title' => t('Use Job Queue to delay saves and deletes'),
      '#default_value' => variable_get('salsa_job_queue', 0),
      '#description' => t("Enabling this option will postpone any save and delete operations to be performed by the Job Queue module during each cron run. Enabling this may result in getting data from Salsa that should have been overwritten already."),
    );
  }

  return system_settings_form($form);
}
